'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.set');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.keys');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.reduce');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.defaultsdeep');

var _lodash8 = _interopRequireDefault(_lodash7);

var _lodash9 = require('lodash.includes');

var _lodash10 = _interopRequireDefault(_lodash9);

var _lodash11 = require('lodash.without');

var _lodash12 = _interopRequireDefault(_lodash11);

var _lodash13 = require('lodash.isstring');

var _lodash14 = _interopRequireDefault(_lodash13);

var _emptyFunc = require('./utils/emptyFunc');

var _emptyFunc2 = _interopRequireDefault(_emptyFunc);

var _arrayFrom = require('./utils/arrayFrom');

var _arrayFrom2 = _interopRequireDefault(_arrayFrom);

var _pickDeep = require('./utils/pickDeep');

var _pickDeep2 = _interopRequireDefault(_pickDeep);

var _joiPickDeep = require('./utils/joiPickDeep');

var _joiPickDeep2 = _interopRequireDefault(_joiPickDeep);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Joi = void 0;

var ALL_PATHS_SYMBOL = '*';
var DEFAULT_STATE = {
  errors: {},
  values: {},
  touchedValues: {},

  validateAllValues: false
};

function includesAllValues(valuePaths) {
  if (Array.isArray(valuePaths)) {
    return (0, _lodash10.default)(valuePaths, ALL_PATHS_SYMBOL);
  } else {
    return valuePaths === ALL_PATHS_SYMBOL;
  }
}

var ReactJoiValidation = function ReactJoiValidation(ValidatedComponent, _ref) {
  var joiSchema = _ref.joiSchema,
      joiOptions = _ref.joiOptions,
      validator = _ref.validator,
      only = _ref.only;

  function usingSingularValidationScope() {
    return (0, _lodash14.default)(only);
  }

  function joiSchemaToUse(valuePaths) {
    if (includesAllValues(valuePaths)) {
      return joiSchema;
    } else {
      return (0, _joiPickDeep2.default)(Joi, joiSchema, valuePaths);
    }
  }

  function scopedPath(valuePath) {
    if (usingSingularValidationScope() && !includesAllValues(valuePath)) {
      return only + '.' + valuePath;
    } else {
      return valuePath;
    }
  }

  var ValidatorComponent = function (_Component) {
    _inherits(ValidatorComponent, _Component);

    function ValidatorComponent(props, context) {
      _classCallCheck(this, ValidatorComponent);

      var _this = _possibleConstructorReturn(this, (ValidatorComponent.__proto__ || Object.getPrototypeOf(ValidatorComponent)).call(this, props, context));

      _this.changeHandler = _this.changeHandler.bind(_this);
      _this.handleChange = _this.handleChange.bind(_this);

      _this.validateHandler = _this.validateHandler.bind(_this);
      _this.validate = _this.validate.bind(_this);

      _this.validateAll = _this.validateAll.bind(_this);
      _this.validateAllHandler = _this.validateAllHandler.bind(_this);

      _this.clear = _this.clear.bind(_this);

      _this.state = _extends({}, DEFAULT_STATE);
      return _this;
    }

    _createClass(ValidatorComponent, [{
      key: 'render',
      value: function render() {
        var errors = this.state.errors;


        return _react2.default.createElement(ValidatedComponent, _extends({}, this.props, this._valuesWithDefaults(), {

          errors: errors,

          changeHandler: this.changeHandler,
          changeValue: this.handleChange,

          validateHandler: this.validateHandler,
          validate: this.validate,

          validateAllHandler: this.validateAllHandler,
          validateAll: this.validateAll,

          clearValidationState: this.clear
        }));
      }
    }, {
      key: 'clear',
      value: function clear() {
        this.setState(_extends({}, DEFAULT_STATE));
      }
    }, {
      key: '_valuesWithDefaults',
      value: function _valuesWithDefaults() {
        var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            scope = _ref2.scope;

        if (only) {

          var validateableFields = (0, _arrayFrom2.default)(only);

          var propValues = (0, _pickDeep2.default)(this.props, validateableFields);

          var defaultValues = (0, _pickDeep2.default)(ValidatedComponent.defaultProps, validateableFields);

          var unscopedValues = (0, _lodash8.default)({}, this.state.values, propValues, defaultValues);

          if (scope && usingSingularValidationScope()) {
            return unscopedValues[only];
          } else {
            return unscopedValues;
          }
        } else {

          return (0, _lodash8.default)({}, this.state.values, this.props, ValidatedComponent.defaultProps);
        }
      }
    }, {
      key: 'changeHandler',
      value: function changeHandler(valuePath) {
        var _this2 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};


        return function (event, value) {
          _this2.handleChange(valuePath, options.value || value, options);
        };
      }
    }, {
      key: 'handleChange',
      value: function handleChange(valuePath, value) {
        var _this3 = this;

        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        var _state = this.state,
            values = _state.values,
            touchedValues = _state.touchedValues;


        this.setState({
          values: (0, _lodash2.default)(_extends({}, values), scopedPath(valuePath), value),
          touchedValues: _extends({}, touchedValues, _defineProperty({}, valuePath, true))
        }, function () {
          if (options.validate) {
            _this3.validate(options.validate === true ? valuePath : options.validate);
          }
        });
      }
    }, {
      key: 'validateAllHandler',
      value: function validateAllHandler() {
        var _this4 = this;

        var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _emptyFunc2.default;


        return function () {
          _this4.validateAll(callback);
        };
      }
    }, {
      key: 'validateAll',
      value: function validateAll(callback) {
        this.validate(ALL_PATHS_SYMBOL, callback);
      }
    }, {
      key: 'validateHandler',
      value: function validateHandler(valuePaths) {
        var _this5 = this;

        var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _emptyFunc2.default)();


        return function () {
          _this5.validate(valuePaths, callback);
        };
      }
    }, {
      key: 'validate',
      value: function validate(valuePaths) {
        var _this6 = this;

        var afterValidationCallback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _emptyFunc2.default;


        var valuePathsAsList = (0, _arrayFrom2.default)(valuePaths);
        var valuePathsWithPrevTouched = this._valuePathsWithTouchedFields(valuePathsAsList);
        var afterValidationHandler = this._afterValidationHandler(valuePathsWithPrevTouched, afterValidationCallback);

        var valuesToValidate = this._getScopedValues(valuePathsWithPrevTouched);

        if (joiSchema) {
          Joi.validate(valuesToValidate, joiSchemaToUse(valuePathsWithPrevTouched), _extends({ abortEarly: false }, joiOptions), function (joiError) {
            var joiErrorList = joiError && joiError.details || [];

            var errorObject = (0, _lodash6.default)(joiErrorList, function (errors, _ref3) {
              var message = _ref3.message,
                  path = _ref3.path;

              var messageWithFieldNameRemoved = message.replace(/^\".+\" /, '');

              (0, _lodash2.default)(errors, path, messageWithFieldNameRemoved);

              return errors;
            }, {});

            _this6._passToValidatorIfValidatingAll(valuePathsWithPrevTouched, valuesToValidate, errorObject, afterValidationHandler);
          });
        } else {

          this._passToValidatorIfValidatingAll(valuePathsWithPrevTouched, valuesToValidate, {}, afterValidationHandler);
        }
      }
    }, {
      key: '_valuePathsWithTouchedFields',
      value: function _valuePathsWithTouchedFields(valuePaths) {
        var _state2 = this.state,
            validateAllValues = _state2.validateAllValues,
            touchedValues = _state2.touchedValues;


        if (includesAllValues(valuePaths) || validateAllValues) {
          return [ALL_PATHS_SYMBOL];
        } else {

          var valuePathsIndexByName = (0, _lodash6.default)(valuePaths, function (memo, valuePath) {
            memo[valuePath] = true;
            return memo;
          }, {});

          return (0, _lodash4.default)(_extends({}, touchedValues, valuePathsIndexByName));
        }
      }
    }, {
      key: '_passToValidatorIfValidatingAll',
      value: function _passToValidatorIfValidatingAll(valuePaths, values, errors, afterValidatorHasRun) {

        if (validator) {
          validator({
            valuePaths: (0, _lodash12.default)(valuePaths, ALL_PATHS_SYMBOL),
            validateAll: includesAllValues(valuePaths),
            values: values, errors: errors
          }, afterValidatorHasRun);
        } else {
          afterValidatorHasRun({ values: values, errors: errors });
        }
      }
    }, {
      key: '_afterValidationHandler',
      value: function _afterValidationHandler(valuePaths, afterValidationComplete) {
        var _this7 = this;

        return function (_ref4) {
          var values = _ref4.values,
              errors = _ref4.errors;
          var _state3 = _this7.state,
              touchedValues = _state3.touchedValues,
              validateAllValues = _state3.validateAllValues;


          var newTouchedValues = function () {

            if (includesAllValues(valuePaths)) {
              return touchedValues;
            } else {
              var _newTouchedValues = (0, _lodash6.default)(valuePaths, function (memo, valuePath) {
                memo[valuePath] = true;
                return memo;
              }, {});

              return _extends({}, touchedValues, _newTouchedValues);
            }
          }();

          var newValues = function () {
            if (usingSingularValidationScope()) {
              return _defineProperty({}, only, values);
            } else {
              return values;
            }
          }();

          var newState = {
            values: newValues, errors: errors,
            touchedValues: newTouchedValues,
            validateAllValues: validateAllValues || includesAllValues(valuePaths)
          };

          _this7.setState(newState, afterValidationComplete);
        };
      }
    }, {
      key: '_getScopedValues',
      value: function _getScopedValues(valuePaths) {
        var values = this._valuesWithDefaults({ scope: true });

        if (includesAllValues(valuePaths)) {
          return values;
        } else {
          return (0, _pickDeep2.default)(values, valuePaths);
        }
      }
    }]);

    return ValidatorComponent;
  }(_react.Component);

  ValidatorComponent.propTypes = {
    onSubmit: _react.PropTypes.func,
    errors: _react.PropTypes.object,
    onChange: _react.PropTypes.func
  };

  return ValidatorComponent;
};

ReactJoiValidation.setJoi = function (joiClass) {
  Joi = joiClass;
};

exports.default = ReactJoiValidation;