'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash.set');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.get');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.pick');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.keys');

var _lodash8 = _interopRequireDefault(_lodash7);

var _lodash9 = require('lodash.some');

var _lodash10 = _interopRequireDefault(_lodash9);

var _lodash11 = require('lodash.reduce');

var _lodash12 = _interopRequireDefault(_lodash11);

var _lodash13 = require('lodash.map');

var _lodash14 = _interopRequireDefault(_lodash13);

var _lodash15 = require('lodash.foreach');

var _lodash16 = _interopRequireDefault(_lodash15);

var _lodash17 = require('lodash.defaultsdeep');

var _lodash18 = _interopRequireDefault(_lodash17);

var _lodash19 = require('lodash.isplainobject');

var _lodash20 = _interopRequireDefault(_lodash19);

var _lodash21 = require('lodash.isundefined');

var _lodash22 = _interopRequireDefault(_lodash21);

var _lodash23 = require('lodash.isstring');

var _lodash24 = _interopRequireDefault(_lodash23);

var _emptyFunc = require('./utils/emptyFunc');

var _emptyFunc2 = _interopRequireDefault(_emptyFunc);

var _arrayFrom = require('./utils/arrayFrom');

var _arrayFrom2 = _interopRequireDefault(_arrayFrom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Joi = void 0;

var ReactJoiValidation = function ReactJoiValidation(ValidatedComponent, _ref) {
  var joiSchema = _ref.joiSchema,
      joiOptions = _ref.joiOptions,
      validator = _ref.validator,
      only = _ref.only;

  var ValidatorComponent = function (_Component) {
    _inherits(ValidatorComponent, _Component);

    function ValidatorComponent(props, context) {
      _classCallCheck(this, ValidatorComponent);

      var _this = _possibleConstructorReturn(this, (ValidatorComponent.__proto__ || Object.getPrototypeOf(ValidatorComponent)).call(this, props, context));

      _this.submitHandler = _this.submitHandler.bind(_this);
      _this.handleSubmit = _this.handleSubmit.bind(_this);

      _this.changeHandler = _this.changeHandler.bind(_this);
      _this.handleChange = _this.handleChange.bind(_this);

      _this.validateHandler = _this.validateHandler.bind(_this);

      _this.state = {
        fieldErrors: {},
        fieldValues: {},
        touchedFields: [],

        validateAllFields: false
      };
      return _this;
    }

    _createClass(ValidatorComponent, [{
      key: 'render',
      value: function render() {
        console.warn('this.state.fieldErrors:');
        console.warn(this.state.fieldErrors);

        return _react2.default.createElement(ValidatedComponent, _extends({}, this.props, this._propsToValidateWithDefaultValuesSet(), {

          errors: this._activeFieldsErrors(),

          changeHandler: this.changeHandler,
          validateHandler: this.validateHandler,
          submitHandler: this.submitHandler,

          onSubmit: this.handleSubmit
        }));
      }
    }, {
      key: '_propsToValidateWithDefaultValuesSet',
      value: function _propsToValidateWithDefaultValuesSet() {

        if (only) {

          var listOfPropsToValidate = (0, _arrayFrom2.default)(only);

          var propValues = this._getValues(this.props, listOfPropsToValidate);

          var defaultValues = this._getValues(ValidatedComponent.defaultProps, listOfPropsToValidate);

          return (0, _lodash18.default)({}, this.state.fieldValues, propValues, defaultValues);
        } else {

          return (0, _lodash18.default)({}, this.state.fieldValues, this.props, ValidatedComponent.defaultProps);
        }
      }
    }, {
      key: '_getValues',
      value: function _getValues(source, paths) {
        return (0, _lodash12.default)(paths, function (memo, path) {

          var sourceValue = (0, _lodash4.default)(source, path);
          (0, _lodash2.default)(memo, path, sourceValue);

          return memo;
        }, {});
      }
    }, {
      key: '_activeFieldsErrors',
      value: function _activeFieldsErrors() {
        var validateAllFields = this.state.validateAllFields;


        if (validateAllFields) {
          return this._errorsForAllFields();
        } else {
          return this._errorsForTouchedFields();
        }
      }
    }, {
      key: '_errorsForAllFields',
      value: function _errorsForAllFields() {
        var fieldErrors = this.state.fieldErrors;


        if ((0, _lodash20.default)(schemaOrValidator)) {
          return (0, _lodash6.default)(fieldErrors, (0, _lodash8.default)(schemaOrValidator));
        } else {
          return fieldErrors;
        }
      }
    }, {
      key: '_errorsForTouchedFields',
      value: function _errorsForTouchedFields() {
        var _state = this.state,
            _state$fieldErrors = _state.fieldErrors,
            fieldErrors = _state$fieldErrors === undefined ? {} : _state$fieldErrors,
            touchedFields = _state.touchedFields;


        return (0, _lodash12.default)(touchedFields, function (touchedFieldErrors, fieldPath) {
          var touchedFieldError = (0, _lodash4.default)(fieldErrors, fieldPath);
          (0, _lodash2.default)(touchedFieldErrors, fieldPath, touchedFieldError);

          return touchedFieldErrors;
        }, {});
      }
    }, {
      key: 'changeHandler',
      value: function changeHandler(fieldPath) {
        var _this2 = this;

        return function (event, value) {
          _this2.handleChange(fieldPath, value);
        };
      }
    }, {
      key: 'handleChange',
      value: function handleChange(fieldPath, value) {

        var newFieldValues = _extends({}, this.state.fieldValues);

        (0, _lodash2.default)(newFieldValues, this._effectiveFieldPath(fieldPath), value);

        this.setState({
          fieldValues: newFieldValues
        });
      }
    }, {
      key: '_effectiveFieldPath',
      value: function _effectiveFieldPath(fieldPath) {

        if ((0, _lodash24.default)(only)) {
          return only + '.' + fieldPath;
        } else {
          return fieldPath;
        }
      }
    }, {
      key: 'submitHandler',
      value: function submitHandler() {
        var nonValidatedAdditionalValues = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        var _this3 = this;

        var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _emptyFunc2.default;
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};


        return function () {
          var nonValidatedAdditionalCallTimeValues = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};


          _this3.handleSubmit(_extends({}, nonValidatedAdditionalValues, nonValidatedAdditionalCallTimeValues), callback, options);
        };
      }
    }, {
      key: 'handleSubmit',
      value: function handleSubmit(nonValidatedAdditionalValues) {
        var _this4 = this;

        var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _emptyFunc2.default;
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};


        this.validate(null, function () {

          if ((0, _lodash10.default)(_this4._activeFieldsErrors()) && !options.ignoreErrors) {

            callback();
          } else {
            var onSubmit = _this4.props.onSubmit;


            var valuesToSubmit = _this4._effectiveFieldValues(_this4._propsToValidateWithDefaultValuesSet());

            onSubmit(valuesToSubmit, nonValidatedAdditionalValues);

            _this4.setState({
              fieldValues: {}
            }, callback);
          }
        });
      }
    }, {
      key: '_effectiveFieldValues',
      value: function _effectiveFieldValues(fieldValues) {

        if ((0, _lodash24.default)(only)) {
          return fieldValues[only];
        } else {
          return fieldValues;
        }
      }
    }, {
      key: 'validateHandler',
      value: function validateHandler(fieldPaths) {
        var _this5 = this;

        return function () {
          _this5.validate(fieldPaths);
        };
      }
    }, {
      key: 'validate',
      value: function validate(fieldPaths) {
        var _this6 = this;

        var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _emptyFunc2.default;

        var listOfFieldPaths = (0, _lodash14.default)((0, _arrayFrom2.default)(fieldPaths), function (fieldPath) {
          return _this6._effectiveFieldPath(fieldPath);
        });

        if (validator) {

          this._validateFieldValuesWithFunction({
            fieldPaths: listOfFieldPaths, callback: callback
          });
        }

        if (joiSchema) {

          this._validateFieldValuesWithJoiSchema({
            fieldPaths: listOfFieldPaths, callback: callback
          });
        }
      }
    }, {
      key: '_validateFieldValuesWithFunction',
      value: function _validateFieldValuesWithFunction(_ref2) {
        var fieldPaths = _ref2.fieldPaths,
            callback = _ref2.callback;

        validator(this._propsToValidateWithDefaultValuesSet(), this._fieldErrorsUpdater(fieldPaths, callback));
      }
    }, {
      key: '_validateFieldValuesWithJoiSchema',
      value: function _validateFieldValuesWithJoiSchema(_ref3) {
        var _this7 = this;

        var fieldPaths = _ref3.fieldPaths,
            callback = _ref3.callback;


        var listOfPropsToValidate = (0, _arrayFrom2.default)(only);

        var unscopedPropsToValidate = this._propsToValidateWithDefaultValuesSet();

        var validateOperations = function () {
          if (listOfPropsToValidate.length === 0) {

            return [{
              props: unscopedPropsToValidate,
              schema: joiSchema,
              pathPrefix: ''
            }];
          } else if (listOfPropsToValidate.length === 1 || !(0, _lodash20.default)(joiSchema)) {

            return [{
              props: unscopedPropsToValidate[only],
              schema: joiSchema,
              pathPrefix: ''
            }];
          } else {
            var allPathsHaveValidationSchema = (0, _lodash10.default)(listOfPropsToValidate, function (path) {
              return (0, _lodash22.default)((0, _lodash4.default)(joiSchema, path));
            });

            invariant(!allPathsHaveValidationSchema, 'The list of props to validate \'' + listOfPropsToValidate + '\' contains one or more items that do not have a corresponding value in the supplied Joi schema. Either define an validation schema for each prop path or do not use a plain object.');

            return (0, _lodash14.default)(listOfPropsToValidate, function (fieldPath) {
              return {
                props: (0, _lodash4.default)(unscopedPropsToValidate, fieldPath),
                schema: Joi.reach(joiSchema, fieldPath),
                pathPrefix: fieldPath + '.'
              };
            });
          }
        }();

        (0, _lodash16.default)(validateOperations, function (_ref4) {
          var props = _ref4.props,
              schema = _ref4.schema,
              pathPrefix = _ref4.pathPrefix;


          Joi.validate(props, schema, _extends({ abortEarly: false }, joiOptions), function (joiError) {
            var errors = joiError && joiError.details || [];
            var fieldErrorsUpdater = _this7._fieldErrorsUpdater(fieldPaths, callback, pathPrefix);

            fieldErrorsUpdater(errors);
          });
        });
      }
    }, {
      key: '_fieldErrorsUpdater',
      value: function _fieldErrorsUpdater(listOfFieldPaths, callback) {
        var _this8 = this;

        var pathPrefix = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';


        return function (errors) {
          var _state2 = _this8.state,
              touchedFields = _state2.touchedFields,
              validateAllFields = _state2.validateAllFields;


          var fieldErrors = (0, _lodash12.default)(errors, function (fieldErrors, _ref5) {
            var message = _ref5.message,
                path = _ref5.path;

            var messageWithFieldNameRemoved = message.replace(/^\".+\" /, '');

            (0, _lodash2.default)(fieldErrors, pathPrefix + path, messageWithFieldNameRemoved);

            return fieldErrors;
          }, {});

          var newState = {
            fieldErrors: fieldErrors,
            touchedFields: [].concat(_toConsumableArray(touchedFields), _toConsumableArray(listOfFieldPaths)),
            validateAllFields: validateAllFields || listOfFieldPaths.length === 0
          };

          _this8.setState(newState, callback);
        };
      }
    }]);

    return ValidatorComponent;
  }(_react.Component);

  ValidatorComponent.propTypes = {
    onSubmit: _react.PropTypes.func,
    fieldErrors: _react.PropTypes.object,
    onChange: _react.PropTypes.func
  };

  return ValidatorComponent;
};

ReactJoiValidation.setJoi = function (joiClass) {
  Joi = joiClass;
};

exports.default = ReactJoiValidation;